import java.awt.*;
import java.applet.Applet;

public class Word extends Applet {
   private TextArea area;
   private Choice fonts;
   private Choice sizes;

   private String currentFont = "Courier";
   private int currentSize = 8;
   private int style = Font.PLAIN;
   private Color currentColor = Color.black;

   public void init() {
      setLayout(new BorderLayout());

      area = new TextArea(10, 60);
      area.setFont(new Font(currentFont, style, currentSize));
      area.setForeground(currentColor);
      add("Center", area);

      Panel p = new Panel();
      p.setLayout(new GridLayout(2,1));

      Panel firstRow = new Panel();
      CheckboxGroup group = new CheckboxGroup();
      firstRow.add(new Checkbox("black", group, true));
      firstRow.add(new Checkbox("blue", group, false));
      firstRow.add(new Checkbox("red", group, false));
      p.add(firstRow);

      Panel secondRow = new Panel();
      fonts = new Choice();
      fonts.addItem("Courier");
      fonts.addItem("Helvetica");
      fonts.addItem("Times Roman");
      secondRow.add(fonts);

      sizes = new Choice();
      sizes.addItem("8");
      sizes.addItem("12");
      sizes.addItem("16");
      secondRow.add(sizes);

      p.add(secondRow);

      add("South", p);
   }

   public boolean action(Event e, Object what) {
      if (e.target instanceof Checkbox) {
         Checkbox c = (Checkbox)(e.target);
         String s = c.getLabel();
         if (s.equals("black"))
            currentColor = Color.black;
         else if (s.equals("blue"))
            currentColor = Color.blue;
         else
            currentColor = Color.red;
      }

      else if (e.target == fonts) {
          currentFont = fonts.getSelectedItem();
      }

      else if (e.target == sizes) {
          switch (sizes.getSelectedIndex()) {
             case 0: currentSize = 8; break;
             case 1: currentSize = 12; break;
             case 2: currentSize = 16; break;
          }
      }

      area.setFont(new Font(currentFont, style, currentSize));
      area.setForeground(currentColor);

      return super.action(e, what);
   }

}
